package example;

import javax.persistence.*;
import org.osgi.framework.*;

public class Activator implements BundleActivator {
  EntityManagerFactory emf;
  public void start(BundleContext ctx) {
   EntityManager em = null;
   ClassLoader old = Thread.currentThread().getContextClassLoader();
   try {
    // Needed for PersistenceProvider to be able to find our persistence unit.
    Thread.currentThread().setContextClassLoader(getClass().getClassLoader());
    emf = Persistence.createEntityManagerFactory("issue_14998");
    em = emf.createEntityManager();
    em.getTransaction().begin();
    UserCredential uc = em.find(UserCredential.class, new Long(1));
    if (uc == null) {
        uc = new UserCredential(1L, "bar");
        em.persist(uc);
    }
    System.out.println(uc);
    em.getTransaction().commit();
   } catch(Exception e) {
    e.printStackTrace();
   } finally {
    if (em != null) { em.close(); }
    Thread.currentThread().setContextClassLoader(old);
   }
  } //start

  public void stop(BundleContext ctx) {
    if (emf != null) { emf.close(); }
  }
}

